// FullAccess
resource "azurerm_role_definition" "azure_sql_database_fullaccess_definition" {
  name              = "azure-sql-database-fullaccess-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = [
      "Microsoft.Sql/unregister/action",
      "Microsoft.Sql/checkNameAvailability/action",
      "Microsoft.Sql/register/action",
      "Microsoft.Sql/servers/databases/azureAsyncOperation/read",
      "Microsoft.Sql/servers/databases/operationResults/read",
      "Microsoft.Sql/servers/databases/metricDefinitions/read",
      "Microsoft.Sql/servers/elasticPools/metricDefinitions/read",
      "Microsoft.Sql/servers/elasticPools/metrics/read",
      "Microsoft.Sql/servers/databases/metrics/read",
      "Microsoft.Sql/locations/syncAgentOperationResults/read",
      "Microsoft.Sql/locations/syncGroupOperationResults/read",
      "Microsoft.Sql/locations/syncMemberOperationResults/read",
      "Microsoft.Sql/locations/elasticPoolAzureAsyncOperation/read",
      "Microsoft.Sql/servers/elasticPools/read",
      "Microsoft.Sql/servers/elasticPools/write",
      "Microsoft.Sql/servers/elasticPools/delete",
      "Microsoft.Sql/servers/elasticPools/failover/action",
      "Microsoft.Sql/managedInstances/databases/vulnerabilityAssessments/write",
      "Microsoft.Sql/managedInstances/databases/vulnerabilityAssessments/delete",
      "Microsoft.Sql/managedInstances/databases/vulnerabilityAssessments/read",
      "Microsoft.Sql/managedInstances/databases/vulnerabilityAssessments/rules/baselines/delete",
      "Microsoft.Sql/managedInstances/databases/vulnerabilityAssessments/rules/baselines/write",
      "Microsoft.Sql/managedInstances/databases/vulnerabilityAssessments/rules/baselines/read",
      "Microsoft.Sql/locations/managedDatabaseRestoreAzureAsyncOperation/completeRestore/action",
      "Microsoft.Sql/servers/databases/restorePoints/read",
      "Microsoft.Sql/servers/databases/restorePoints/delete",
      "Microsoft.Sql/servers/databases/read",
      "Microsoft.Sql/servers/databases/write",
      "Microsoft.Sql/servers/databases/delete",
      "Microsoft.Sql/servers/databases/pause/action",
      "Microsoft.Sql/servers/databases/resume/action",
      "Microsoft.Sql/servers/databases/export/action",
      "Microsoft.Sql/servers/databases/upgradeDataWarehouse/action",
      "Microsoft.Sql/servers/databases/move/action",
      "Microsoft.Sql/servers/databases/restorePoints/action",
      "Microsoft.Sql/servers/databases/failover/action",
      "Microsoft.Sql/servers/databases/vulnerabilityAssessmentScans/action",
      "Microsoft.Sql/managedInstances/administrators/read",
      "Microsoft.Sql/managedInstances/administrators/write",
      "Microsoft.Sql/managedInstances/administrators/delete",
      "Microsoft.Sql/servers/databases/extendedAuditingSettings/read",
      "Microsoft.Sql/servers/databases/extendedAuditingSettings/write",
      "Microsoft.Sql/locations/extendedAuditingSettingsAzureAsyncOperation/read",
      "Microsoft.Sql/locations/extendedAuditingSettingsOperationResults/read",
      "Microsoft.Sql/servers/extendedAuditingSettings/read",
      "Microsoft.Sql/servers/extendedAuditingSettings/write",
      "Microsoft.Sql/servers/databases/skus/read",
      "Microsoft.Sql/servers/elasticPools/databases/read",
      "Microsoft.Sql/locations/databaseOperationResults/read",
      "Microsoft.Sql/servers/restorableDroppedDatabases/read",
      "Microsoft.Sql/servers/elasticPools/skus/read",
      "Microsoft.Sql/locations/capabilities/read",
      "Microsoft.Sql/servers/tdeCertificates/action",
      "Microsoft.Sql/servers/import/action",
      "Microsoft.Sql/servers/read",
      "Microsoft.Sql/servers/write",
      "Microsoft.Sql/servers/delete",
      "Microsoft.Sql/managedInstances/tdeCertificates/action",
      "Microsoft.Sql/managedInstances/read",
      "Microsoft.Sql/managedInstances/write",
      "Microsoft.Sql/managedInstances/delete",
      "Microsoft.Sql/managedInstances/databases/vulnerabilityAssessments/scans/initiateScan/action",
      "Microsoft.Sql/managedInstances/databases/vulnerabilityAssessments/scans/export/action",
      "Microsoft.Sql/managedInstances/databases/vulnerabilityAssessments/scans/read",
      "Microsoft.Sql/servers/databases/vulnerabilityAssessments/scans/initiateScan/action",
      "Microsoft.Sql/servers/databases/vulnerabilityAssessments/scans/read",
      "Microsoft.Sql/servers/databases/vulnerabilityAssessments/scans/export/action",
      "Microsoft.Sql/servers/databases/dataWarehouseUserActivities/read",
      "Microsoft.Sql/servers/databases/sensitivityLabels/read",
      "Microsoft.Sql/managedInstances/securityAlertPolicies/write",
      "Microsoft.Sql/managedInstances/securityAlertPolicies/read",
      "Microsoft.Sql/locations/longTermRetentionServers/longTermRetentionDatabases/longTermRetentionBackups/read",
      "Microsoft.Sql/locations/longTermRetentionServers/longTermRetentionDatabases/longTermRetentionBackups/delete",
      "Microsoft.Sql/locations/elasticPoolOperationResults/read",
      "Microsoft.Sql/locations/usages/read",
      "Microsoft.Sql/servers/administratorOperationResults/read",
      "Microsoft.Sql/servers/importExportOperationResults/read",
      "Microsoft.Sql/servers/operationResults/read",
      "Microsoft.Sql/servers/databases/transparentDataEncryption/operationResults/read",
      "Microsoft.Sql/managedInstances/databases/securityAlertPolicies/write",
      "Microsoft.Sql/managedInstances/databases/securityAlertPolicies/read",
      "Microsoft.Sql/locations/longTermRetentionBackups/read",
      "Microsoft.Sql/servers/databases/backupLongTermRetentionPolicies/write",
      "Microsoft.Sql/servers/databases/backupLongTermRetentionPolicies/read",
      "Microsoft.Sql/locations/longTermRetentionServers/longTermRetentionBackups/read",
      "Microsoft.Sql/servers/databases/vulnerabilityAssessments/write",
      "Microsoft.Sql/servers/databases/vulnerabilityAssessments/delete",
      "Microsoft.Sql/servers/databases/vulnerabilityAssessments/read",
      "Microsoft.Sql/servers/databases/vulnerabilityAssessments/rules/baselines/delete",
      "Microsoft.Sql/servers/databases/vulnerabilityAssessments/rules/baselines/write",
      "Microsoft.Sql/servers/databases/vulnerabilityAssessments/rules/baselines/read",
      "Microsoft.Sql/managedInstances/databases/read",
      "Microsoft.Sql/managedInstances/databases/delete",
      "Microsoft.Sql/managedInstances/databases/write",
      "Microsoft.Sql/managedInstances/metricDefinitions/read",
      "Microsoft.Sql/managedInstances/metrics/read",
      "Microsoft.Sql/servers/administrators/read",
      "Microsoft.Sql/servers/administrators/write",
      "Microsoft.Sql/servers/administrators/delete",
      "Microsoft.Sql/servers/databases/schemas/tables/columns/read",
      "Microsoft.Sql/servers/databases/auditingPolicies/read",
      "Microsoft.Sql/servers/databases/auditingPolicies/write",
      "Microsoft.Sql/servers/databases/connectionPolicies/read",
      "Microsoft.Sql/servers/databases/connectionPolicies/write",
      "Microsoft.Sql/servers/databases/extensions/read",
      "Microsoft.Sql/servers/databases/extensions/write",
      "Microsoft.Sql/servers/databases/queryStore/read",
      "Microsoft.Sql/servers/databases/queryStore/write",
      "Microsoft.Sql/servers/databases/schemas/read",
      "Microsoft.Sql/servers/databases/securityAlertPolicies/write",
      "Microsoft.Sql/servers/databases/securityAlertPolicies/read",
      "Microsoft.Sql/servers/databases/securityMetrics/read",
      "Microsoft.Sql/servers/databases/usages/read",
      "Microsoft.Sql/servers/databases/dataMaskingPolicies/read",
      "Microsoft.Sql/servers/databases/dataMaskingPolicies/write",
      "Microsoft.Sql/servers/databases/dataMaskingPolicies/rules/read",
      "Microsoft.Sql/servers/databases/dataMaskingPolicies/rules/write",
      "Microsoft.Sql/servers/databases/dataMaskingPolicies/rules/delete",
      "Microsoft.Sql/servers/databases/dataWarehouseQueries/read",
      "Microsoft.Sql/servers/databases/dataWarehouseQueries/dataWarehouseQuerySteps/read",
      "Microsoft.Sql/servers/disasterRecoveryConfiguration/read",
      "Microsoft.Sql/servers/disasterRecoveryConfiguration/write",
      "Microsoft.Sql/servers/disasterRecoveryConfiguration/delete",
      "Microsoft.Sql/servers/disasterRecoveryConfiguration/failover/action",
      "Microsoft.Sql/servers/disasterRecoveryConfiguration/forceFailoverAllowDataLoss/action",
      "Microsoft.Sql/servers/elasticPools/elasticPoolActivity/read",
      "Microsoft.Sql/servers/elasticPools/elasticPoolDatabaseActivity/read",
      "Microsoft.Sql/servers/databases/geoBackupPolicies/read",
      "Microsoft.Sql/servers/databases/geoBackupPolicies/write",
      "Microsoft.Sql/locations/read",
      "Microsoft.Sql/servers/databases/topQueries/statistics/read",
      "Microsoft.Sql/servers/databases/topQueries/queryText/action",
      "Microsoft.Sql/servers/databases/topQueries/read",
      "Microsoft.Sql/servers/recommendedElasticPools/read",
      "Microsoft.Sql/servers/recommendedElasticPools/databases/read",
      "Microsoft.Sql/servers/databases/schemas/tables/recommendedIndexes/read",
      "Microsoft.Sql/servers/databases/schemas/tables/recommendedIndexes/write",
      "Microsoft.Sql/servers/recoverableDatabases/read",
      "Microsoft.Sql/servers/databases/replicationLinks/read",
      "Microsoft.Sql/servers/databases/replicationLinks/delete",
      "Microsoft.Sql/servers/databases/replicationLinks/failover/action",
      "Microsoft.Sql/servers/databases/replicationLinks/forceFailoverAllowDataLoss/action",
      "Microsoft.Sql/servers/databases/replicationLinks/updateReplicationMode/action",
      "Microsoft.Sql/servers/databases/replicationLinks/unlink/action",
      "Microsoft.Sql/servers/auditingPolicies/read",
      "Microsoft.Sql/servers/auditingPolicies/write",
      "Microsoft.Sql/servers/backupLongTermRetentionVaults/read",
      "Microsoft.Sql/servers/backupLongTermRetentionVaults/write",
      "Microsoft.Sql/servers/backupLongTermRetentionVaults/delete",
      "Microsoft.Sql/servers/communicationLinks/read",
      "Microsoft.Sql/servers/communicationLinks/write",
      "Microsoft.Sql/servers/communicationLinks/delete",
      "Microsoft.Sql/servers/connectionPolicies/read",
      "Microsoft.Sql/servers/connectionPolicies/write",
      "Microsoft.Sql/servers/usages/read",
      "Microsoft.Sql/servers/serviceObjectives/read",
      "Microsoft.Sql/servers/databases/serviceTierAdvisors/read",
      "Microsoft.Sql/servers/databases/schemas/tables/read",
      "Microsoft.Sql/servers/databases/transparentDataEncryption/read",
      "Microsoft.Sql/servers/databases/transparentDataEncryption/write",
      "Microsoft.Sql/virtualClusters/read",
      "Microsoft.Sql/virtualClusters/write",
      "Microsoft.Sql/virtualClusters/delete",
      "Microsoft.Sql/locations/auditingSettingsOperationResults/read",
      "Microsoft.Sql/locations/auditingSettingsAzureAsyncOperation/read",
      "Microsoft.Sql/servers/auditingSettings/read",
      "Microsoft.Sql/servers/auditingSettings/write",
      "Microsoft.Sql/servers/databases/auditingSettings/read",
      "Microsoft.Sql/servers/databases/auditingSettings/write",
      "Microsoft.Sql/servers/databases/auditRecords/read",
      "Microsoft.Sql/servers/auditingSettings/operationResults/read",
      "Microsoft.Sql/servers/databases/operations/cancel/action",
      "Microsoft.Sql/servers/databases/operations/read",
      "Microsoft.Sql/locations/deletedServers/read",
      "Microsoft.Sql/locations/deletedServers/recover/action",
      "Microsoft.Sql/locations/deletedServerAsyncOperation/read",
      "Microsoft.Sql/locations/deletedServerOperationResults/read",
      "Microsoft.Sql/locations/databaseAzureAsyncOperation/read",
      "Microsoft.Sql/servers/databases/schemas/tables/columns/sensitivityLabels/enable/action",
      "Microsoft.Sql/servers/databases/schemas/tables/columns/sensitivityLabels/disable/action",
      "Microsoft.Sql/servers/databases/schemas/tables/columns/sensitivityLabels/read",
      "Microsoft.Sql/servers/databases/schemas/tables/columns/sensitivityLabels/write",
      "Microsoft.Sql/servers/databases/schemas/tables/columns/sensitivityLabels/delete",
      "Microsoft.Sql/servers/automaticTuning/read",
      "Microsoft.Sql/servers/automaticTuning/write",
      "Microsoft.Sql/managedInstances/databases/transparentDataEncryption/read",
      "Microsoft.Sql/managedInstances/databases/transparentDataEncryption/write",
      "Microsoft.Sql/locations/managedTransparentDataEncryptionOperationResults/read",
      "Microsoft.Sql/locations/managedTransparentDataEncryptionAzureAsyncOperation/read",
      "Microsoft.Sql/servers/syncAgents/read",
      "Microsoft.Sql/servers/syncAgents/write",
      "Microsoft.Sql/servers/syncAgents/delete",
      "Microsoft.Sql/servers/syncAgents/generateKey/action",
      "Microsoft.Sql/servers/syncAgents/linkedDatabases/read",
      "Microsoft.Sql/locations/syncDatabaseIds/read",
      "Microsoft.Sql/servers/databases/syncGroups/refreshHubSchema/action",
      "Microsoft.Sql/servers/databases/syncGroups/cancelSync/action",
      "Microsoft.Sql/servers/databases/syncGroups/triggerSync/action",
      "Microsoft.Sql/servers/databases/syncGroups/read",
      "Microsoft.Sql/servers/databases/syncGroups/write",
      "Microsoft.Sql/servers/databases/syncGroups/delete",
      "Microsoft.Sql/servers/databases/syncGroups/refreshHubSchemaOperationResults/read",
      "Microsoft.Sql/servers/databases/syncGroups/hubSchemas/read",
      "Microsoft.Sql/servers/databases/syncGroups/syncMembers/refreshSchemaOperationResults/read",
      "Microsoft.Sql/servers/encryptionProtector/read",
      "Microsoft.Sql/servers/encryptionProtector/write",
      "Microsoft.Sql/servers/databases/queryStore/queryTexts/read",
      "Microsoft.Sql/servers/firewallRules/write",
      "Microsoft.Sql/servers/firewallRules/read",
      "Microsoft.Sql/servers/firewallRules/delete",
      "Microsoft.Sql/servers/keys/read",
      "Microsoft.Sql/servers/keys/write",
      "Microsoft.Sql/servers/keys/delete",
      "Microsoft.Sql/servers/databases/syncGroups/logs/read",
      "Microsoft.Sql/servers/databases/syncGroups/syncMembers/read",
      "Microsoft.Sql/servers/databases/syncGroups/syncMembers/write",
      "Microsoft.Sql/servers/databases/syncGroups/syncMembers/delete",
      "Microsoft.Sql/servers/databases/syncGroups/syncMembers/refreshSchema/action",
      "Microsoft.Sql/servers/databases/syncGroups/syncMembers/schemas/read",
      "Microsoft.Sql/servers/elasticPoolEstimates/read",
      "Microsoft.Sql/servers/elasticPoolEstimates/write",
      "Microsoft.Sql/operations/read",
      "Microsoft.Sql/servers/securityAlertPolicies/operationResults/read",
      "Microsoft.Sql/servers/databases/vulnerabilityAssessmentSettings/read",
      "Microsoft.Sql/servers/databases/vulnerabilityAssessmentSettings/write",
      "Microsoft.Sql/servers/databases/vulnerabilityAssessmentScans/operationResults/read",
      "Microsoft.Sql/servers/failoverGroups/read",
      "Microsoft.Sql/servers/failoverGroups/write",
      "Microsoft.Sql/servers/failoverGroups/delete",
      "Microsoft.Sql/servers/failoverGroups/failover/action",
      "Microsoft.Sql/servers/failoverGroups/forceFailoverAllowDataLoss/action",
      "Microsoft.Sql/servers/securityAlertPolicies/write",
      "Microsoft.Sql/servers/securityAlertPolicies/read",
      "Microsoft.Sql/servers/virtualNetworkRules/read",
      "Microsoft.Sql/servers/virtualNetworkRules/write",
      "Microsoft.Sql/servers/virtualNetworkRules/delete",
      "Microsoft.Sql/locations/virtualNetworkRulesAzureAsyncOperation/read",
      "Microsoft.Sql/locations/virtualNetworkRulesOperationResults/read",
      "Microsoft.Sql/servers/databases/advisors/read",
      "Microsoft.Sql/servers/databases/advisors/write",
      "Microsoft.Sql/servers/databases/automaticTuning/read",
      "Microsoft.Sql/servers/databases/automaticTuning/write",
      "Microsoft.Sql/servers/databases/advisors/recommendedActions/read",
      "Microsoft.Sql/servers/databases/advisors/recommendedActions/write",
      "Microsoft.Sql/servers/elasticPools/advisors/read",
      "Microsoft.Sql/servers/elasticPools/advisors/write",
      "Microsoft.Sql/servers/elasticPools/advisors/recommendedActions/read",
      "Microsoft.Sql/servers/elasticPools/advisors/recommendedActions/write",
      "Microsoft.Sql/servers/advisors/read",
      "Microsoft.Sql/servers/advisors/write",
      "Microsoft.Sql/servers/advisors/recommendedActions/read",
      "Microsoft.Sql/servers/advisors/recommendedActions/write",
      "Microsoft.Sql/servers/databases/importExportOperationResults/read",
      "Microsoft.Sql/servers/elasticPools/operations/cancel/action",
      "Microsoft.Sql/servers/elasticPools/operations/read",
      "Microsoft.Sql/managedInstances/databases/securityEvents/read",
      "Microsoft.Sql/locations/instanceFailoverGroups/read",
      "Microsoft.Sql/locations/instanceFailoverGroups/write",
      "Microsoft.Sql/locations/instanceFailoverGroups/delete",
      "Microsoft.Sql/locations/instanceFailoverGroups/failover/action",
      "Microsoft.Sql/locations/instanceFailoverGroups/forceFailoverAllowDataLoss/action",
      "Microsoft.Sql/servers/databases/providers/Microsoft.Insights/metricDefinitions/read",
      "Microsoft.Sql/servers/databases/providers/Microsoft.Insights/diagnosticSettings/read",
      "Microsoft.Sql/servers/databases/providers/Microsoft.Insights/diagnosticSettings/write",
      "Microsoft.Sql/servers/databases/providers/Microsoft.Insights/logDefinitions/read",
      "Microsoft.Sql/servers/elasticPools/providers/Microsoft.Insights/metricDefinitions/read",
      "Microsoft.Sql/servers/elasticPools/providers/Microsoft.Insights/diagnosticSettings/read",
      "Microsoft.Sql/servers/elasticPools/providers/Microsoft.Insights/diagnosticSettings/write",
      "Microsoft.Sql/servers/providers/Microsoft.Insights/metricDefinitions/read",
      "Microsoft.Sql/servers/replicationLinks/read",
      "Microsoft.Sql/managedInstances/encryptionProtector/read",
      "Microsoft.Sql/managedInstances/encryptionProtector/write",
      "Microsoft.Sql/managedInstances/keys/read",
      "Microsoft.Sql/managedInstances/keys/write",
      "Microsoft.Sql/managedInstances/keys/delete",
      "Microsoft.Sql/servers/databases/maintenanceWindowOptions/read",
      "Microsoft.Sql/servers/databases/maintenanceWindows/read",
      "Microsoft.Sql/servers/databases/maintenanceWindows/write",
      "Microsoft.Sql/servers/interfaceEndpointProfiles/write",
      "Microsoft.Sql/servers/interfaceEndpointProfiles/read",
      "Microsoft.Sql/servers/interfaceEndpointProfiles/delete",
      "Microsoft.Sql/locations/interfaceEndpointProfileAzureAsyncOperation/read",
      "Microsoft.Sql/locations/interfaceEndpointProfileOperationResults/read",
      "Microsoft.Sql/managedInstances/vulnerabilityAssessments/write",
      "Microsoft.Sql/managedInstances/vulnerabilityAssessments/delete",
      "Microsoft.Sql/managedInstances/vulnerabilityAssessments/read",
      "Microsoft.Sql/servers/vulnerabilityAssessments/write",
      "Microsoft.Sql/servers/vulnerabilityAssessments/delete",
      "Microsoft.Sql/servers/vulnerabilityAssessments/read",
      "Microsoft.Sql/managedInstances/providers/Microsoft.Insights/metricDefinitions/read",
      "Microsoft.Sql/managedInstances/providers/Microsoft.Insights/logDefinitions/read",
      "Microsoft.Sql/managedInstances/providers/Microsoft.Insights/diagnosticSettings/read",
      "Microsoft.Sql/managedInstances/providers/Microsoft.Insights/diagnosticSettings/write",
      "Microsoft.Sql/managedInstances/databases/providers/Microsoft.Insights/logDefinitions/read",
      "Microsoft.Sql/managedInstances/databases/providers/Microsoft.Insights/diagnosticSettings/read",
      "Microsoft.Sql/managedInstances/databases/providers/Microsoft.Insights/diagnosticSettings/write",
      "Microsoft.Sql/managedInstances/restorableDroppedDatabases/read",
      "Microsoft.Sql/managedInstances/databases/backupShortTermRetentionPolicies/read",
      "Microsoft.Sql/managedInstances/databases/backupShortTermRetentionPolicies/write",
      "Microsoft.Sql/managedInstances/restorableDroppedDatabases/backupShortTermRetentionPolicies/read",
      "Microsoft.Sql/managedInstances/restorableDroppedDatabases/backupShortTermRetentionPolicies/write",
      "Microsoft.Sql/servers/jobAgents/read",
      "Microsoft.Sql/servers/jobAgents/write",
      "Microsoft.Sql/servers/jobAgents/delete",
      "Microsoft.Sql/locations/jobAgentAzureAsyncOperation/read",
      "Microsoft.Sql/locations/jobAgentOperationResults/read",
      "Microsoft.Sql/managedInstances/databases/schemas/tables/columns/sensitivityLabels/read",
      "Microsoft.Sql/managedInstances/databases/schemas/tables/columns/sensitivityLabels/write",
      "Microsoft.Sql/managedInstances/databases/schemas/tables/columns/sensitivityLabels/delete",
      "Microsoft.Sql/managedInstances/databases/schemas/tables/columns/sensitivityLabels/disable/action",
      "Microsoft.Sql/managedInstances/databases/schemas/tables/columns/sensitivityLabels/enable/action",
      "Microsoft.Sql/managedInstances/databases/sensitivityLabels/read",
      "Microsoft.Sql/managedInstances/databases/currentSensitivityLabels/read",
      "Microsoft.Sql/managedInstances/databases/currentSensitivityLabels/write",
      "Microsoft.Sql/managedInstances/databases/recommendedSensitivityLabels/read",
      "Microsoft.Sql/servers/databases/currentSensitivityLabels/read",
      "Microsoft.Sql/servers/databases/currentSensitivityLabels/write",
      "Microsoft.Sql/servers/databases/recommendedSensitivityLabels/read",
      "Microsoft.Sql/locations/firewallRulesAzureAsyncOperation/read",
      "Microsoft.Sql/locations/firewallRulesOperationResults/read",
      "Microsoft.Sql/managedInstances/recoverableDatabases/read",
      "Microsoft.Sql/instancePools/read",
      "Microsoft.Sql/instancePools/write",
      "Microsoft.Sql/instancePools/delete",
      "Microsoft.Sql/locations/instancePoolAzureAsyncOperation/read",
      "Microsoft.Sql/locations/instancePoolOperationResults/read",
      "Microsoft.Sql/instancePools/usages/read",
      "Microsoft.Sql/managedInstances/databases/schemas/tables/columns/read",
      "Microsoft.Sql/managedInstances/databases/schemas/read",
      "Microsoft.Sql/managedInstances/databases/schemas/tables/read",
      "Microsoft.Sql/locations/managedInstanceKeyAzureAsyncOperation/read",
      "Microsoft.Sql/locations/managedInstanceKeyOperationResults/read",
      "Microsoft.Sql/locations/managedInstanceEncryptionProtectorAzureAsyncOperation/read",
      "Microsoft.Sql/locations/managedInstanceEncryptionProtectorOperationResults/read",
      "Microsoft.Sql/locations/serverKeyAzureAsyncOperation/read",
      "Microsoft.Sql/locations/serverKeyOperationResults/read",
      "Microsoft.Sql/locations/encryptionProtectorAzureAsyncOperation/read",
      "Microsoft.Sql/locations/encryptionProtectorOperationResults/read",
      "Microsoft.Sql/servers/privateEndpointConnections/read",
      "Microsoft.Sql/servers/privateEndpointConnections/delete",
      "Microsoft.Sql/servers/privateEndpointConnections/write",
      "Microsoft.Sql/locations/privateEndpointConnectionProxyOperationResults/read",
      "Microsoft.Sql/servers/privateEndpointConnectionProxies/validate/action",
      "Microsoft.Sql/servers/privateEndpointConnectionProxies/read",
      "Microsoft.Sql/servers/privateEndpointConnectionProxies/write",
      "Microsoft.Sql/servers/privateEndpointConnectionProxies/delete",
      "Microsoft.Sql/locations/privateEndpointConnectionProxyAzureAsyncOperation/read",
      "Microsoft.Sql/servers/databases/backupShortTermRetentionPolicies/read",
      "Microsoft.Sql/servers/databases/backupShortTermRetentionPolicies/write",
      "Microsoft.Sql/locations/privateEndpointConnectionOperationResults/read",
      "Microsoft.Sql/locations/privateEndpointConnectionAzureAsyncOperation/read",
      "Microsoft.Sql/servers/privateLinkResources/read",
    ]

    not_actions = []
  }
}

// ReadOnly
resource "azurerm_role_definition" "azure_sql_database_readonly_definition" {
  name              = "azure-sql-database-readonly-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = [
      "Microsoft.Sql/servers/databases/azureAsyncOperation/read",
      "Microsoft.Sql/servers/databases/operationResults/read",
      "Microsoft.Sql/servers/databases/metricDefinitions/read",
      "Microsoft.Sql/servers/elasticPools/metricDefinitions/read",
      "Microsoft.Sql/servers/elasticPools/metrics/read",
      "Microsoft.Sql/servers/databases/metrics/read",
      "Microsoft.Sql/locations/syncAgentOperationResults/read",
      "Microsoft.Sql/locations/syncGroupOperationResults/read",
      "Microsoft.Sql/locations/syncMemberOperationResults/read",
      "Microsoft.Sql/locations/elasticPoolAzureAsyncOperation/read",
      "Microsoft.Sql/servers/elasticPools/read",
      "Microsoft.Sql/managedInstances/databases/vulnerabilityAssessments/read",
      "Microsoft.Sql/managedInstances/databases/vulnerabilityAssessments/rules/baselines/read",
      "Microsoft.Sql/servers/databases/restorePoints/read",
      "Microsoft.Sql/servers/databases/read",
      "Microsoft.Sql/managedInstances/administrators/read",
      "Microsoft.Sql/servers/databases/extendedAuditingSettings/read",
      "Microsoft.Sql/locations/extendedAuditingSettingsAzureAsyncOperation/read",
      "Microsoft.Sql/locations/extendedAuditingSettingsOperationResults/read",
      "Microsoft.Sql/servers/extendedAuditingSettings/read",
      "Microsoft.Sql/servers/databases/skus/read",
      "Microsoft.Sql/servers/elasticPools/databases/read",
      "Microsoft.Sql/locations/databaseOperationResults/read",
      "Microsoft.Sql/servers/restorableDroppedDatabases/read",
      "Microsoft.Sql/servers/elasticPools/skus/read",
      "Microsoft.Sql/locations/capabilities/read",
      "Microsoft.Sql/servers/read",
      "Microsoft.Sql/managedInstances/read",
      "Microsoft.Sql/managedInstances/databases/vulnerabilityAssessments/scans/read",
      "Microsoft.Sql/servers/databases/vulnerabilityAssessments/scans/read",
      "Microsoft.Sql/servers/databases/dataWarehouseUserActivities/read",
      "Microsoft.Sql/servers/databases/sensitivityLabels/read",
      "Microsoft.Sql/managedInstances/securityAlertPolicies/read",
      "Microsoft.Sql/locations/longTermRetentionServers/longTermRetentionDatabases/longTermRetentionBackups/read",
      "Microsoft.Sql/locations/elasticPoolOperationResults/read",
      "Microsoft.Sql/locations/usages/read",
      "Microsoft.Sql/servers/administratorOperationResults/read",
      "Microsoft.Sql/servers/importExportOperationResults/read",
      "Microsoft.Sql/servers/operationResults/read",
      "Microsoft.Sql/servers/databases/transparentDataEncryption/operationResults/read",
      "Microsoft.Sql/managedInstances/databases/securityAlertPolicies/read",
      "Microsoft.Sql/locations/longTermRetentionBackups/read",
      "Microsoft.Sql/servers/databases/backupLongTermRetentionPolicies/read",
      "Microsoft.Sql/locations/longTermRetentionServers/longTermRetentionBackups/read",
      "Microsoft.Sql/servers/databases/vulnerabilityAssessments/read",
      "Microsoft.Sql/servers/databases/vulnerabilityAssessments/rules/baselines/read",
      "Microsoft.Sql/managedInstances/databases/read",
      "Microsoft.Sql/managedInstances/metricDefinitions/read",
      "Microsoft.Sql/managedInstances/metrics/read",
      "Microsoft.Sql/servers/administrators/read",
      "Microsoft.Sql/servers/databases/schemas/tables/columns/read",
      "Microsoft.Sql/servers/databases/auditingPolicies/read",
      "Microsoft.Sql/servers/databases/connectionPolicies/read",
      "Microsoft.Sql/servers/databases/extensions/read",
      "Microsoft.Sql/servers/databases/queryStore/read",
      "Microsoft.Sql/servers/databases/schemas/read",
      "Microsoft.Sql/servers/databases/securityAlertPolicies/read",
      "Microsoft.Sql/servers/databases/securityMetrics/read",
      "Microsoft.Sql/servers/databases/usages/read",
      "Microsoft.Sql/servers/databases/dataMaskingPolicies/read",
      "Microsoft.Sql/servers/databases/dataMaskingPolicies/rules/read",
      "Microsoft.Sql/servers/databases/dataWarehouseQueries/read",
      "Microsoft.Sql/servers/databases/dataWarehouseQueries/dataWarehouseQuerySteps/read",
      "Microsoft.Sql/servers/disasterRecoveryConfiguration/read",
      "Microsoft.Sql/servers/elasticPools/elasticPoolActivity/read",
      "Microsoft.Sql/servers/elasticPools/elasticPoolDatabaseActivity/read",
      "Microsoft.Sql/servers/databases/geoBackupPolicies/read",
      "Microsoft.Sql/locations/read",
      "Microsoft.Sql/servers/databases/topQueries/statistics/read",
      "Microsoft.Sql/servers/databases/topQueries/read",
      "Microsoft.Sql/servers/recommendedElasticPools/read",
      "Microsoft.Sql/servers/recommendedElasticPools/databases/read",
      "Microsoft.Sql/servers/databases/schemas/tables/recommendedIndexes/read",
      "Microsoft.Sql/servers/recoverableDatabases/read",
      "Microsoft.Sql/servers/databases/replicationLinks/read",
      "Microsoft.Sql/servers/auditingPolicies/read",
      "Microsoft.Sql/servers/backupLongTermRetentionVaults/read",
      "Microsoft.Sql/servers/communicationLinks/read",
      "Microsoft.Sql/servers/connectionPolicies/read",
      "Microsoft.Sql/servers/usages/read",
      "Microsoft.Sql/servers/serviceObjectives/read",
      "Microsoft.Sql/servers/databases/serviceTierAdvisors/read",
      "Microsoft.Sql/servers/databases/schemas/tables/read",
      "Microsoft.Sql/servers/databases/transparentDataEncryption/read",
      "Microsoft.Sql/virtualClusters/read",
      "Microsoft.Sql/locations/auditingSettingsOperationResults/read",
      "Microsoft.Sql/locations/auditingSettingsAzureAsyncOperation/read",
      "Microsoft.Sql/servers/auditingSettings/read",
      "Microsoft.Sql/servers/databases/auditingSettings/read",
      "Microsoft.Sql/servers/databases/auditRecords/read",
      "Microsoft.Sql/servers/auditingSettings/operationResults/read",
      "Microsoft.Sql/servers/databases/operations/read",
      "Microsoft.Sql/locations/deletedServers/read",
      "Microsoft.Sql/locations/deletedServerAsyncOperation/read",
      "Microsoft.Sql/locations/deletedServerOperationResults/read",
      "Microsoft.Sql/locations/databaseAzureAsyncOperation/read",
      "Microsoft.Sql/servers/databases/schemas/tables/columns/sensitivityLabels/read",
      "Microsoft.Sql/servers/automaticTuning/read",
      "Microsoft.Sql/managedInstances/databases/transparentDataEncryption/read",
      "Microsoft.Sql/locations/managedTransparentDataEncryptionOperationResults/read",
      "Microsoft.Sql/locations/managedTransparentDataEncryptionAzureAsyncOperation/read",
      "Microsoft.Sql/servers/syncAgents/read",
      "Microsoft.Sql/servers/syncAgents/linkedDatabases/read",
      "Microsoft.Sql/locations/syncDatabaseIds/read",
      "Microsoft.Sql/servers/databases/syncGroups/read",
      "Microsoft.Sql/servers/databases/syncGroups/refreshHubSchemaOperationResults/read",
      "Microsoft.Sql/servers/databases/syncGroups/hubSchemas/read",
      "Microsoft.Sql/servers/databases/syncGroups/syncMembers/refreshSchemaOperationResults/read",
      "Microsoft.Sql/servers/encryptionProtector/read",
      "Microsoft.Sql/servers/databases/queryStore/queryTexts/read",
      "Microsoft.Sql/servers/firewallRules/read",
      "Microsoft.Sql/servers/keys/read",
      "Microsoft.Sql/servers/databases/syncGroups/logs/read",
      "Microsoft.Sql/servers/databases/syncGroups/syncMembers/read",
      "Microsoft.Sql/servers/databases/syncGroups/syncMembers/schemas/read",
      "Microsoft.Sql/servers/elasticPoolEstimates/read",
      "Microsoft.Sql/operations/read",
      "Microsoft.Sql/servers/securityAlertPolicies/operationResults/read",
      "Microsoft.Sql/servers/databases/vulnerabilityAssessmentSettings/read",
      "Microsoft.Sql/servers/databases/vulnerabilityAssessmentScans/operationResults/read",
      "Microsoft.Sql/servers/failoverGroups/read",
      "Microsoft.Sql/servers/securityAlertPolicies/read",
      "Microsoft.Sql/servers/virtualNetworkRules/read",
      "Microsoft.Sql/locations/virtualNetworkRulesAzureAsyncOperation/read",
      "Microsoft.Sql/locations/virtualNetworkRulesOperationResults/read",
      "Microsoft.Sql/servers/databases/advisors/read",
      "Microsoft.Sql/servers/databases/automaticTuning/read",
      "Microsoft.Sql/servers/databases/advisors/recommendedActions/read",
      "Microsoft.Sql/servers/elasticPools/advisors/read",
      "Microsoft.Sql/servers/elasticPools/advisors/recommendedActions/read",
      "Microsoft.Sql/servers/advisors/read",
      "Microsoft.Sql/servers/advisors/recommendedActions/read",
      "Microsoft.Sql/servers/databases/importExportOperationResults/read",
      "Microsoft.Sql/servers/elasticPools/operations/read",
      "Microsoft.Sql/managedInstances/databases/securityEvents/read",
      "Microsoft.Sql/locations/instanceFailoverGroups/read",
      "Microsoft.Sql/servers/databases/providers/Microsoft.Insights/metricDefinitions/read",
      "Microsoft.Sql/servers/databases/providers/Microsoft.Insights/diagnosticSettings/read",
      "Microsoft.Sql/servers/databases/providers/Microsoft.Insights/logDefinitions/read",
      "Microsoft.Sql/servers/elasticPools/providers/Microsoft.Insights/metricDefinitions/read",
      "Microsoft.Sql/servers/elasticPools/providers/Microsoft.Insights/diagnosticSettings/read",
      "Microsoft.Sql/servers/providers/Microsoft.Insights/metricDefinitions/read",
      "Microsoft.Sql/servers/replicationLinks/read",
      "Microsoft.Sql/managedInstances/encryptionProtector/read",
      "Microsoft.Sql/managedInstances/keys/read",
      "Microsoft.Sql/servers/databases/maintenanceWindowOptions/read",
      "Microsoft.Sql/servers/databases/maintenanceWindows/read",
      "Microsoft.Sql/servers/interfaceEndpointProfiles/read",
      "Microsoft.Sql/locations/interfaceEndpointProfileAzureAsyncOperation/read",
      "Microsoft.Sql/locations/interfaceEndpointProfileOperationResults/read",
      "Microsoft.Sql/managedInstances/vulnerabilityAssessments/read",
      "Microsoft.Sql/servers/vulnerabilityAssessments/read",
      "Microsoft.Sql/managedInstances/providers/Microsoft.Insights/metricDefinitions/read",
      "Microsoft.Sql/managedInstances/providers/Microsoft.Insights/logDefinitions/read",
      "Microsoft.Sql/managedInstances/providers/Microsoft.Insights/diagnosticSettings/read",
      "Microsoft.Sql/managedInstances/databases/providers/Microsoft.Insights/logDefinitions/read",
      "Microsoft.Sql/managedInstances/databases/providers/Microsoft.Insights/diagnosticSettings/read",
      "Microsoft.Sql/managedInstances/restorableDroppedDatabases/read",
      "Microsoft.Sql/managedInstances/databases/backupShortTermRetentionPolicies/read",
      "Microsoft.Sql/managedInstances/restorableDroppedDatabases/backupShortTermRetentionPolicies/read",
      "Microsoft.Sql/servers/jobAgents/read",
      "Microsoft.Sql/locations/jobAgentAzureAsyncOperation/read",
      "Microsoft.Sql/locations/jobAgentOperationResults/read",
      "Microsoft.Sql/managedInstances/databases/schemas/tables/columns/sensitivityLabels/read",
      "Microsoft.Sql/managedInstances/databases/sensitivityLabels/read",
      "Microsoft.Sql/managedInstances/databases/currentSensitivityLabels/read",
      "Microsoft.Sql/managedInstances/databases/recommendedSensitivityLabels/read",
      "Microsoft.Sql/servers/databases/currentSensitivityLabels/read",
      "Microsoft.Sql/servers/databases/recommendedSensitivityLabels/read",
      "Microsoft.Sql/locations/firewallRulesAzureAsyncOperation/read",
      "Microsoft.Sql/locations/firewallRulesOperationResults/read",
      "Microsoft.Sql/managedInstances/recoverableDatabases/read",
      "Microsoft.Sql/instancePools/read",
      "Microsoft.Sql/locations/instancePoolAzureAsyncOperation/read",
      "Microsoft.Sql/locations/instancePoolOperationResults/read",
      "Microsoft.Sql/instancePools/usages/read",
      "Microsoft.Sql/managedInstances/databases/schemas/tables/columns/read",
      "Microsoft.Sql/managedInstances/databases/schemas/read",
      "Microsoft.Sql/managedInstances/databases/schemas/tables/read",
      "Microsoft.Sql/locations/managedInstanceKeyAzureAsyncOperation/read",
      "Microsoft.Sql/locations/managedInstanceKeyOperationResults/read",
      "Microsoft.Sql/locations/managedInstanceEncryptionProtectorAzureAsyncOperation/read",
      "Microsoft.Sql/locations/managedInstanceEncryptionProtectorOperationResults/read",
      "Microsoft.Sql/locations/serverKeyAzureAsyncOperation/read",
      "Microsoft.Sql/locations/serverKeyOperationResults/read",
      "Microsoft.Sql/locations/encryptionProtectorAzureAsyncOperation/read",
      "Microsoft.Sql/locations/encryptionProtectorOperationResults/read",
      "Microsoft.Sql/servers/privateEndpointConnections/read",
      "Microsoft.Sql/locations/privateEndpointConnectionProxyOperationResults/read",
      "Microsoft.Sql/servers/privateEndpointConnectionProxies/read",
      "Microsoft.Sql/locations/privateEndpointConnectionProxyAzureAsyncOperation/read",
      "Microsoft.Sql/servers/databases/backupShortTermRetentionPolicies/read",
      "Microsoft.Sql/locations/privateEndpointConnectionOperationResults/read",
      "Microsoft.Sql/locations/privateEndpointConnectionAzureAsyncOperation/read",
      "Microsoft.Sql/servers/privateLinkResources/read",
    ]

    not_actions = [
      "Microsoft.Sql/unregister/action",
      "Microsoft.Sql/checkNameAvailability/action",
      "Microsoft.Sql/register/action",
      "Microsoft.Sql/servers/elasticPools/write",
      "Microsoft.Sql/servers/elasticPools/delete",
      "Microsoft.Sql/servers/elasticPools/failover/action",
      "Microsoft.Sql/managedInstances/databases/vulnerabilityAssessments/write",
      "Microsoft.Sql/managedInstances/databases/vulnerabilityAssessments/delete",
      "Microsoft.Sql/managedInstances/databases/vulnerabilityAssessments/rules/baselines/delete",
      "Microsoft.Sql/managedInstances/databases/vulnerabilityAssessments/rules/baselines/write",
      "Microsoft.Sql/locations/managedDatabaseRestoreAzureAsyncOperation/completeRestore/action",
      "Microsoft.Sql/servers/databases/restorePoints/delete",
      "Microsoft.Sql/servers/databases/write",
      "Microsoft.Sql/servers/databases/delete",
      "Microsoft.Sql/servers/databases/pause/action",
      "Microsoft.Sql/servers/databases/resume/action",
      "Microsoft.Sql/servers/databases/export/action",
      "Microsoft.Sql/servers/databases/upgradeDataWarehouse/action",
      "Microsoft.Sql/servers/databases/move/action",
      "Microsoft.Sql/servers/databases/restorePoints/action",
      "Microsoft.Sql/servers/databases/failover/action",
      "Microsoft.Sql/servers/databases/vulnerabilityAssessmentScans/action",
      "Microsoft.Sql/managedInstances/administrators/write",
      "Microsoft.Sql/managedInstances/administrators/delete",
      "Microsoft.Sql/servers/databases/extendedAuditingSettings/write",
      "Microsoft.Sql/servers/extendedAuditingSettings/write",
      "Microsoft.Sql/servers/tdeCertificates/action",
      "Microsoft.Sql/servers/import/action",
      "Microsoft.Sql/servers/write",
      "Microsoft.Sql/servers/delete",
      "Microsoft.Sql/managedInstances/tdeCertificates/action",
      "Microsoft.Sql/managedInstances/write",
      "Microsoft.Sql/managedInstances/delete",
      "Microsoft.Sql/managedInstances/databases/vulnerabilityAssessments/scans/initiateScan/action",
      "Microsoft.Sql/managedInstances/databases/vulnerabilityAssessments/scans/export/action",
      "Microsoft.Sql/servers/databases/vulnerabilityAssessments/scans/initiateScan/action",
      "Microsoft.Sql/servers/databases/vulnerabilityAssessments/scans/export/action",
      "Microsoft.Sql/managedInstances/securityAlertPolicies/write",
      "Microsoft.Sql/locations/longTermRetentionServers/longTermRetentionDatabases/longTermRetentionBackups/delete",
      "Microsoft.Sql/managedInstances/databases/securityAlertPolicies/write",
      "Microsoft.Sql/servers/databases/backupLongTermRetentionPolicies/write",
      "Microsoft.Sql/servers/databases/vulnerabilityAssessments/write",
      "Microsoft.Sql/servers/databases/vulnerabilityAssessments/delete",
      "Microsoft.Sql/servers/databases/vulnerabilityAssessments/rules/baselines/delete",
      "Microsoft.Sql/servers/databases/vulnerabilityAssessments/rules/baselines/write",
      "Microsoft.Sql/managedInstances/databases/delete",
      "Microsoft.Sql/managedInstances/databases/write",
      "Microsoft.Sql/servers/administrators/write",
      "Microsoft.Sql/servers/administrators/delete",
      "Microsoft.Sql/servers/databases/auditingPolicies/write",
      "Microsoft.Sql/servers/databases/connectionPolicies/write",
      "Microsoft.Sql/servers/databases/extensions/write",
      "Microsoft.Sql/servers/databases/queryStore/write",
      "Microsoft.Sql/servers/databases/securityAlertPolicies/write",
      "Microsoft.Sql/servers/databases/dataMaskingPolicies/write",
      "Microsoft.Sql/servers/databases/dataMaskingPolicies/rules/write",
      "Microsoft.Sql/servers/databases/dataMaskingPolicies/rules/delete",
      "Microsoft.Sql/servers/disasterRecoveryConfiguration/write",
      "Microsoft.Sql/servers/disasterRecoveryConfiguration/delete",
      "Microsoft.Sql/servers/disasterRecoveryConfiguration/failover/action",
      "Microsoft.Sql/servers/disasterRecoveryConfiguration/forceFailoverAllowDataLoss/action",
      "Microsoft.Sql/servers/databases/geoBackupPolicies/write",
      "Microsoft.Sql/servers/databases/topQueries/queryText/action",
      "Microsoft.Sql/servers/databases/schemas/tables/recommendedIndexes/write",
      "Microsoft.Sql/servers/databases/replicationLinks/delete",
      "Microsoft.Sql/servers/databases/replicationLinks/failover/action",
      "Microsoft.Sql/servers/databases/replicationLinks/forceFailoverAllowDataLoss/action",
      "Microsoft.Sql/servers/databases/replicationLinks/updateReplicationMode/action",
      "Microsoft.Sql/servers/databases/replicationLinks/unlink/action",
      "Microsoft.Sql/servers/auditingPolicies/write",
      "Microsoft.Sql/servers/backupLongTermRetentionVaults/write",
      "Microsoft.Sql/servers/backupLongTermRetentionVaults/delete",
      "Microsoft.Sql/servers/communicationLinks/write",
      "Microsoft.Sql/servers/communicationLinks/delete",
      "Microsoft.Sql/servers/connectionPolicies/write",
      "Microsoft.Sql/servers/databases/transparentDataEncryption/write",
      "Microsoft.Sql/virtualClusters/write",
      "Microsoft.Sql/virtualClusters/delete",
      "Microsoft.Sql/servers/auditingSettings/write",
      "Microsoft.Sql/servers/databases/auditingSettings/write",
      "Microsoft.Sql/servers/databases/operations/cancel/action",
      "Microsoft.Sql/locations/deletedServers/recover/action",
      "Microsoft.Sql/servers/databases/schemas/tables/columns/sensitivityLabels/enable/action",
      "Microsoft.Sql/servers/databases/schemas/tables/columns/sensitivityLabels/disable/action",
      "Microsoft.Sql/servers/databases/schemas/tables/columns/sensitivityLabels/write",
      "Microsoft.Sql/servers/databases/schemas/tables/columns/sensitivityLabels/delete",
      "Microsoft.Sql/servers/automaticTuning/write",
      "Microsoft.Sql/managedInstances/databases/transparentDataEncryption/write",
      "Microsoft.Sql/servers/syncAgents/write",
      "Microsoft.Sql/servers/syncAgents/delete",
      "Microsoft.Sql/servers/syncAgents/generateKey/action",
      "Microsoft.Sql/servers/databases/syncGroups/refreshHubSchema/action",
      "Microsoft.Sql/servers/databases/syncGroups/cancelSync/action",
      "Microsoft.Sql/servers/databases/syncGroups/triggerSync/action",
      "Microsoft.Sql/servers/databases/syncGroups/write",
      "Microsoft.Sql/servers/databases/syncGroups/delete",
      "Microsoft.Sql/servers/encryptionProtector/write",
      "Microsoft.Sql/servers/firewallRules/write",
      "Microsoft.Sql/servers/firewallRules/delete",
      "Microsoft.Sql/servers/keys/write",
      "Microsoft.Sql/servers/keys/delete",
      "Microsoft.Sql/servers/databases/syncGroups/syncMembers/write",
      "Microsoft.Sql/servers/databases/syncGroups/syncMembers/delete",
      "Microsoft.Sql/servers/databases/syncGroups/syncMembers/refreshSchema/action",
      "Microsoft.Sql/servers/elasticPoolEstimates/write",
      "Microsoft.Sql/servers/databases/vulnerabilityAssessmentSettings/write",
      "Microsoft.Sql/servers/failoverGroups/write",
      "Microsoft.Sql/servers/failoverGroups/delete",
      "Microsoft.Sql/servers/failoverGroups/failover/action",
      "Microsoft.Sql/servers/failoverGroups/forceFailoverAllowDataLoss/action",
      "Microsoft.Sql/servers/securityAlertPolicies/write",
      "Microsoft.Sql/servers/virtualNetworkRules/write",
      "Microsoft.Sql/servers/virtualNetworkRules/delete",
      "Microsoft.Sql/servers/databases/advisors/write",
      "Microsoft.Sql/servers/databases/automaticTuning/write",
      "Microsoft.Sql/servers/databases/advisors/recommendedActions/write",
      "Microsoft.Sql/servers/elasticPools/advisors/write",
      "Microsoft.Sql/servers/elasticPools/advisors/recommendedActions/write",
      "Microsoft.Sql/servers/advisors/write",
      "Microsoft.Sql/servers/advisors/recommendedActions/write",
      "Microsoft.Sql/servers/elasticPools/operations/cancel/action",
      "Microsoft.Sql/locations/instanceFailoverGroups/write",
      "Microsoft.Sql/locations/instanceFailoverGroups/delete",
      "Microsoft.Sql/locations/instanceFailoverGroups/failover/action",
      "Microsoft.Sql/locations/instanceFailoverGroups/forceFailoverAllowDataLoss/action",
      "Microsoft.Sql/servers/databases/providers/Microsoft.Insights/diagnosticSettings/write",
      "Microsoft.Sql/servers/elasticPools/providers/Microsoft.Insights/diagnosticSettings/write",
      "Microsoft.Sql/managedInstances/encryptionProtector/write",
      "Microsoft.Sql/managedInstances/keys/write",
      "Microsoft.Sql/managedInstances/keys/delete",
      "Microsoft.Sql/servers/databases/maintenanceWindows/write",
      "Microsoft.Sql/servers/interfaceEndpointProfiles/write",
      "Microsoft.Sql/servers/interfaceEndpointProfiles/delete",
      "Microsoft.Sql/managedInstances/vulnerabilityAssessments/write",
      "Microsoft.Sql/managedInstances/vulnerabilityAssessments/delete",
      "Microsoft.Sql/servers/vulnerabilityAssessments/write",
      "Microsoft.Sql/servers/vulnerabilityAssessments/delete",
      "Microsoft.Sql/managedInstances/providers/Microsoft.Insights/diagnosticSettings/write",
      "Microsoft.Sql/managedInstances/databases/providers/Microsoft.Insights/diagnosticSettings/write",
      "Microsoft.Sql/managedInstances/databases/backupShortTermRetentionPolicies/write",
      "Microsoft.Sql/managedInstances/restorableDroppedDatabases/backupShortTermRetentionPolicies/write",
      "Microsoft.Sql/servers/jobAgents/write",
      "Microsoft.Sql/servers/jobAgents/delete",
      "Microsoft.Sql/managedInstances/databases/schemas/tables/columns/sensitivityLabels/write",
      "Microsoft.Sql/managedInstances/databases/schemas/tables/columns/sensitivityLabels/delete",
      "Microsoft.Sql/managedInstances/databases/schemas/tables/columns/sensitivityLabels/disable/action",
      "Microsoft.Sql/managedInstances/databases/schemas/tables/columns/sensitivityLabels/enable/action",
      "Microsoft.Sql/managedInstances/databases/currentSensitivityLabels/write",
      "Microsoft.Sql/servers/databases/currentSensitivityLabels/write",
      "Microsoft.Sql/instancePools/write",
      "Microsoft.Sql/instancePools/delete",
      "Microsoft.Sql/servers/privateEndpointConnections/delete",
      "Microsoft.Sql/servers/privateEndpointConnections/write",
      "Microsoft.Sql/servers/privateEndpointConnectionProxies/validate/action",
      "Microsoft.Sql/servers/privateEndpointConnectionProxies/write",
      "Microsoft.Sql/servers/privateEndpointConnectionProxies/delete",
      "Microsoft.Sql/servers/databases/backupShortTermRetentionPolicies/write",
    ]
  }
}

// NoAccess
resource "azurerm_role_definition" "azure_sql_database_noaccess_definition" {
  name              = "azure-sql-database-noaccess-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = []

    not_actions = [
      "Microsoft.Sql/unregister/action",
      "Microsoft.Sql/checkNameAvailability/action",
      "Microsoft.Sql/register/action",
      "Microsoft.Sql/servers/databases/azureAsyncOperation/read",
      "Microsoft.Sql/servers/databases/operationResults/read",
      "Microsoft.Sql/servers/databases/metricDefinitions/read",
      "Microsoft.Sql/servers/elasticPools/metricDefinitions/read",
      "Microsoft.Sql/servers/elasticPools/metrics/read",
      "Microsoft.Sql/servers/databases/metrics/read",
      "Microsoft.Sql/locations/syncAgentOperationResults/read",
      "Microsoft.Sql/locations/syncGroupOperationResults/read",
      "Microsoft.Sql/locations/syncMemberOperationResults/read",
      "Microsoft.Sql/locations/elasticPoolAzureAsyncOperation/read",
      "Microsoft.Sql/servers/elasticPools/read",
      "Microsoft.Sql/servers/elasticPools/write",
      "Microsoft.Sql/servers/elasticPools/delete",
      "Microsoft.Sql/servers/elasticPools/failover/action",
      "Microsoft.Sql/managedInstances/databases/vulnerabilityAssessments/write",
      "Microsoft.Sql/managedInstances/databases/vulnerabilityAssessments/delete",
      "Microsoft.Sql/managedInstances/databases/vulnerabilityAssessments/read",
      "Microsoft.Sql/managedInstances/databases/vulnerabilityAssessments/rules/baselines/delete",
      "Microsoft.Sql/managedInstances/databases/vulnerabilityAssessments/rules/baselines/write",
      "Microsoft.Sql/managedInstances/databases/vulnerabilityAssessments/rules/baselines/read",
      "Microsoft.Sql/locations/managedDatabaseRestoreAzureAsyncOperation/completeRestore/action",
      "Microsoft.Sql/servers/databases/restorePoints/read",
      "Microsoft.Sql/servers/databases/restorePoints/delete",
      "Microsoft.Sql/servers/databases/read",
      "Microsoft.Sql/servers/databases/write",
      "Microsoft.Sql/servers/databases/delete",
      "Microsoft.Sql/servers/databases/pause/action",
      "Microsoft.Sql/servers/databases/resume/action",
      "Microsoft.Sql/servers/databases/export/action",
      "Microsoft.Sql/servers/databases/upgradeDataWarehouse/action",
      "Microsoft.Sql/servers/databases/move/action",
      "Microsoft.Sql/servers/databases/restorePoints/action",
      "Microsoft.Sql/servers/databases/failover/action",
      "Microsoft.Sql/servers/databases/vulnerabilityAssessmentScans/action",
      "Microsoft.Sql/managedInstances/administrators/read",
      "Microsoft.Sql/managedInstances/administrators/write",
      "Microsoft.Sql/managedInstances/administrators/delete",
      "Microsoft.Sql/servers/databases/extendedAuditingSettings/read",
      "Microsoft.Sql/servers/databases/extendedAuditingSettings/write",
      "Microsoft.Sql/locations/extendedAuditingSettingsAzureAsyncOperation/read",
      "Microsoft.Sql/locations/extendedAuditingSettingsOperationResults/read",
      "Microsoft.Sql/servers/extendedAuditingSettings/read",
      "Microsoft.Sql/servers/extendedAuditingSettings/write",
      "Microsoft.Sql/servers/databases/skus/read",
      "Microsoft.Sql/servers/elasticPools/databases/read",
      "Microsoft.Sql/locations/databaseOperationResults/read",
      "Microsoft.Sql/servers/restorableDroppedDatabases/read",
      "Microsoft.Sql/servers/elasticPools/skus/read",
      "Microsoft.Sql/locations/capabilities/read",
      "Microsoft.Sql/servers/tdeCertificates/action",
      "Microsoft.Sql/servers/import/action",
      "Microsoft.Sql/servers/read",
      "Microsoft.Sql/servers/write",
      "Microsoft.Sql/servers/delete",
      "Microsoft.Sql/managedInstances/tdeCertificates/action",
      "Microsoft.Sql/managedInstances/read",
      "Microsoft.Sql/managedInstances/write",
      "Microsoft.Sql/managedInstances/delete",
      "Microsoft.Sql/managedInstances/databases/vulnerabilityAssessments/scans/initiateScan/action",
      "Microsoft.Sql/managedInstances/databases/vulnerabilityAssessments/scans/export/action",
      "Microsoft.Sql/managedInstances/databases/vulnerabilityAssessments/scans/read",
      "Microsoft.Sql/servers/databases/vulnerabilityAssessments/scans/initiateScan/action",
      "Microsoft.Sql/servers/databases/vulnerabilityAssessments/scans/read",
      "Microsoft.Sql/servers/databases/vulnerabilityAssessments/scans/export/action",
      "Microsoft.Sql/servers/databases/dataWarehouseUserActivities/read",
      "Microsoft.Sql/servers/databases/sensitivityLabels/read",
      "Microsoft.Sql/managedInstances/securityAlertPolicies/write",
      "Microsoft.Sql/managedInstances/securityAlertPolicies/read",
      "Microsoft.Sql/locations/longTermRetentionServers/longTermRetentionDatabases/longTermRetentionBackups/read",
      "Microsoft.Sql/locations/longTermRetentionServers/longTermRetentionDatabases/longTermRetentionBackups/delete",
      "Microsoft.Sql/locations/elasticPoolOperationResults/read",
      "Microsoft.Sql/locations/usages/read",
      "Microsoft.Sql/servers/administratorOperationResults/read",
      "Microsoft.Sql/servers/importExportOperationResults/read",
      "Microsoft.Sql/servers/operationResults/read",
      "Microsoft.Sql/servers/databases/transparentDataEncryption/operationResults/read",
      "Microsoft.Sql/managedInstances/databases/securityAlertPolicies/write",
      "Microsoft.Sql/managedInstances/databases/securityAlertPolicies/read",
      "Microsoft.Sql/locations/longTermRetentionBackups/read",
      "Microsoft.Sql/servers/databases/backupLongTermRetentionPolicies/write",
      "Microsoft.Sql/servers/databases/backupLongTermRetentionPolicies/read",
      "Microsoft.Sql/locations/longTermRetentionServers/longTermRetentionBackups/read",
      "Microsoft.Sql/servers/databases/vulnerabilityAssessments/write",
      "Microsoft.Sql/servers/databases/vulnerabilityAssessments/delete",
      "Microsoft.Sql/servers/databases/vulnerabilityAssessments/read",
      "Microsoft.Sql/servers/databases/vulnerabilityAssessments/rules/baselines/delete",
      "Microsoft.Sql/servers/databases/vulnerabilityAssessments/rules/baselines/write",
      "Microsoft.Sql/servers/databases/vulnerabilityAssessments/rules/baselines/read",
      "Microsoft.Sql/managedInstances/databases/read",
      "Microsoft.Sql/managedInstances/databases/delete",
      "Microsoft.Sql/managedInstances/databases/write",
      "Microsoft.Sql/managedInstances/metricDefinitions/read",
      "Microsoft.Sql/managedInstances/metrics/read",
      "Microsoft.Sql/servers/administrators/read",
      "Microsoft.Sql/servers/administrators/write",
      "Microsoft.Sql/servers/administrators/delete",
      "Microsoft.Sql/servers/databases/schemas/tables/columns/read",
      "Microsoft.Sql/servers/databases/auditingPolicies/read",
      "Microsoft.Sql/servers/databases/auditingPolicies/write",
      "Microsoft.Sql/servers/databases/connectionPolicies/read",
      "Microsoft.Sql/servers/databases/connectionPolicies/write",
      "Microsoft.Sql/servers/databases/extensions/read",
      "Microsoft.Sql/servers/databases/extensions/write",
      "Microsoft.Sql/servers/databases/queryStore/read",
      "Microsoft.Sql/servers/databases/queryStore/write",
      "Microsoft.Sql/servers/databases/schemas/read",
      "Microsoft.Sql/servers/databases/securityAlertPolicies/write",
      "Microsoft.Sql/servers/databases/securityAlertPolicies/read",
      "Microsoft.Sql/servers/databases/securityMetrics/read",
      "Microsoft.Sql/servers/databases/usages/read",
      "Microsoft.Sql/servers/databases/dataMaskingPolicies/read",
      "Microsoft.Sql/servers/databases/dataMaskingPolicies/write",
      "Microsoft.Sql/servers/databases/dataMaskingPolicies/rules/read",
      "Microsoft.Sql/servers/databases/dataMaskingPolicies/rules/write",
      "Microsoft.Sql/servers/databases/dataMaskingPolicies/rules/delete",
      "Microsoft.Sql/servers/databases/dataWarehouseQueries/read",
      "Microsoft.Sql/servers/databases/dataWarehouseQueries/dataWarehouseQuerySteps/read",
      "Microsoft.Sql/servers/disasterRecoveryConfiguration/read",
      "Microsoft.Sql/servers/disasterRecoveryConfiguration/write",
      "Microsoft.Sql/servers/disasterRecoveryConfiguration/delete",
      "Microsoft.Sql/servers/disasterRecoveryConfiguration/failover/action",
      "Microsoft.Sql/servers/disasterRecoveryConfiguration/forceFailoverAllowDataLoss/action",
      "Microsoft.Sql/servers/elasticPools/elasticPoolActivity/read",
      "Microsoft.Sql/servers/elasticPools/elasticPoolDatabaseActivity/read",
      "Microsoft.Sql/servers/databases/geoBackupPolicies/read",
      "Microsoft.Sql/servers/databases/geoBackupPolicies/write",
      "Microsoft.Sql/locations/read",
      "Microsoft.Sql/servers/databases/topQueries/statistics/read",
      "Microsoft.Sql/servers/databases/topQueries/queryText/action",
      "Microsoft.Sql/servers/databases/topQueries/read",
      "Microsoft.Sql/servers/recommendedElasticPools/read",
      "Microsoft.Sql/servers/recommendedElasticPools/databases/read",
      "Microsoft.Sql/servers/databases/schemas/tables/recommendedIndexes/read",
      "Microsoft.Sql/servers/databases/schemas/tables/recommendedIndexes/write",
      "Microsoft.Sql/servers/recoverableDatabases/read",
      "Microsoft.Sql/servers/databases/replicationLinks/read",
      "Microsoft.Sql/servers/databases/replicationLinks/delete",
      "Microsoft.Sql/servers/databases/replicationLinks/failover/action",
      "Microsoft.Sql/servers/databases/replicationLinks/forceFailoverAllowDataLoss/action",
      "Microsoft.Sql/servers/databases/replicationLinks/updateReplicationMode/action",
      "Microsoft.Sql/servers/databases/replicationLinks/unlink/action",
      "Microsoft.Sql/servers/auditingPolicies/read",
      "Microsoft.Sql/servers/auditingPolicies/write",
      "Microsoft.Sql/servers/backupLongTermRetentionVaults/read",
      "Microsoft.Sql/servers/backupLongTermRetentionVaults/write",
      "Microsoft.Sql/servers/backupLongTermRetentionVaults/delete",
      "Microsoft.Sql/servers/communicationLinks/read",
      "Microsoft.Sql/servers/communicationLinks/write",
      "Microsoft.Sql/servers/communicationLinks/delete",
      "Microsoft.Sql/servers/connectionPolicies/read",
      "Microsoft.Sql/servers/connectionPolicies/write",
      "Microsoft.Sql/servers/usages/read",
      "Microsoft.Sql/servers/serviceObjectives/read",
      "Microsoft.Sql/servers/databases/serviceTierAdvisors/read",
      "Microsoft.Sql/servers/databases/schemas/tables/read",
      "Microsoft.Sql/servers/databases/transparentDataEncryption/read",
      "Microsoft.Sql/servers/databases/transparentDataEncryption/write",
      "Microsoft.Sql/virtualClusters/read",
      "Microsoft.Sql/virtualClusters/write",
      "Microsoft.Sql/virtualClusters/delete",
      "Microsoft.Sql/locations/auditingSettingsOperationResults/read",
      "Microsoft.Sql/locations/auditingSettingsAzureAsyncOperation/read",
      "Microsoft.Sql/servers/auditingSettings/read",
      "Microsoft.Sql/servers/auditingSettings/write",
      "Microsoft.Sql/servers/databases/auditingSettings/read",
      "Microsoft.Sql/servers/databases/auditingSettings/write",
      "Microsoft.Sql/servers/databases/auditRecords/read",
      "Microsoft.Sql/servers/auditingSettings/operationResults/read",
      "Microsoft.Sql/servers/databases/operations/cancel/action",
      "Microsoft.Sql/servers/databases/operations/read",
      "Microsoft.Sql/locations/deletedServers/read",
      "Microsoft.Sql/locations/deletedServers/recover/action",
      "Microsoft.Sql/locations/deletedServerAsyncOperation/read",
      "Microsoft.Sql/locations/deletedServerOperationResults/read",
      "Microsoft.Sql/locations/databaseAzureAsyncOperation/read",
      "Microsoft.Sql/servers/databases/schemas/tables/columns/sensitivityLabels/enable/action",
      "Microsoft.Sql/servers/databases/schemas/tables/columns/sensitivityLabels/disable/action",
      "Microsoft.Sql/servers/databases/schemas/tables/columns/sensitivityLabels/read",
      "Microsoft.Sql/servers/databases/schemas/tables/columns/sensitivityLabels/write",
      "Microsoft.Sql/servers/databases/schemas/tables/columns/sensitivityLabels/delete",
      "Microsoft.Sql/servers/automaticTuning/read",
      "Microsoft.Sql/servers/automaticTuning/write",
      "Microsoft.Sql/managedInstances/databases/transparentDataEncryption/read",
      "Microsoft.Sql/managedInstances/databases/transparentDataEncryption/write",
      "Microsoft.Sql/locations/managedTransparentDataEncryptionOperationResults/read",
      "Microsoft.Sql/locations/managedTransparentDataEncryptionAzureAsyncOperation/read",
      "Microsoft.Sql/servers/syncAgents/read",
      "Microsoft.Sql/servers/syncAgents/write",
      "Microsoft.Sql/servers/syncAgents/delete",
      "Microsoft.Sql/servers/syncAgents/generateKey/action",
      "Microsoft.Sql/servers/syncAgents/linkedDatabases/read",
      "Microsoft.Sql/locations/syncDatabaseIds/read",
      "Microsoft.Sql/servers/databases/syncGroups/refreshHubSchema/action",
      "Microsoft.Sql/servers/databases/syncGroups/cancelSync/action",
      "Microsoft.Sql/servers/databases/syncGroups/triggerSync/action",
      "Microsoft.Sql/servers/databases/syncGroups/read",
      "Microsoft.Sql/servers/databases/syncGroups/write",
      "Microsoft.Sql/servers/databases/syncGroups/delete",
      "Microsoft.Sql/servers/databases/syncGroups/refreshHubSchemaOperationResults/read",
      "Microsoft.Sql/servers/databases/syncGroups/hubSchemas/read",
      "Microsoft.Sql/servers/databases/syncGroups/syncMembers/refreshSchemaOperationResults/read",
      "Microsoft.Sql/servers/encryptionProtector/read",
      "Microsoft.Sql/servers/encryptionProtector/write",
      "Microsoft.Sql/servers/databases/queryStore/queryTexts/read",
      "Microsoft.Sql/servers/firewallRules/write",
      "Microsoft.Sql/servers/firewallRules/read",
      "Microsoft.Sql/servers/firewallRules/delete",
      "Microsoft.Sql/servers/keys/read",
      "Microsoft.Sql/servers/keys/write",
      "Microsoft.Sql/servers/keys/delete",
      "Microsoft.Sql/servers/databases/syncGroups/logs/read",
      "Microsoft.Sql/servers/databases/syncGroups/syncMembers/read",
      "Microsoft.Sql/servers/databases/syncGroups/syncMembers/write",
      "Microsoft.Sql/servers/databases/syncGroups/syncMembers/delete",
      "Microsoft.Sql/servers/databases/syncGroups/syncMembers/refreshSchema/action",
      "Microsoft.Sql/servers/databases/syncGroups/syncMembers/schemas/read",
      "Microsoft.Sql/servers/elasticPoolEstimates/read",
      "Microsoft.Sql/servers/elasticPoolEstimates/write",
      "Microsoft.Sql/operations/read",
      "Microsoft.Sql/servers/securityAlertPolicies/operationResults/read",
      "Microsoft.Sql/servers/databases/vulnerabilityAssessmentSettings/read",
      "Microsoft.Sql/servers/databases/vulnerabilityAssessmentSettings/write",
      "Microsoft.Sql/servers/databases/vulnerabilityAssessmentScans/operationResults/read",
      "Microsoft.Sql/servers/failoverGroups/read",
      "Microsoft.Sql/servers/failoverGroups/write",
      "Microsoft.Sql/servers/failoverGroups/delete",
      "Microsoft.Sql/servers/failoverGroups/failover/action",
      "Microsoft.Sql/servers/failoverGroups/forceFailoverAllowDataLoss/action",
      "Microsoft.Sql/servers/securityAlertPolicies/write",
      "Microsoft.Sql/servers/securityAlertPolicies/read",
      "Microsoft.Sql/servers/virtualNetworkRules/read",
      "Microsoft.Sql/servers/virtualNetworkRules/write",
      "Microsoft.Sql/servers/virtualNetworkRules/delete",
      "Microsoft.Sql/locations/virtualNetworkRulesAzureAsyncOperation/read",
      "Microsoft.Sql/locations/virtualNetworkRulesOperationResults/read",
      "Microsoft.Sql/servers/databases/advisors/read",
      "Microsoft.Sql/servers/databases/advisors/write",
      "Microsoft.Sql/servers/databases/automaticTuning/read",
      "Microsoft.Sql/servers/databases/automaticTuning/write",
      "Microsoft.Sql/servers/databases/advisors/recommendedActions/read",
      "Microsoft.Sql/servers/databases/advisors/recommendedActions/write",
      "Microsoft.Sql/servers/elasticPools/advisors/read",
      "Microsoft.Sql/servers/elasticPools/advisors/write",
      "Microsoft.Sql/servers/elasticPools/advisors/recommendedActions/read",
      "Microsoft.Sql/servers/elasticPools/advisors/recommendedActions/write",
      "Microsoft.Sql/servers/advisors/read",
      "Microsoft.Sql/servers/advisors/write",
      "Microsoft.Sql/servers/advisors/recommendedActions/read",
      "Microsoft.Sql/servers/advisors/recommendedActions/write",
      "Microsoft.Sql/servers/databases/importExportOperationResults/read",
      "Microsoft.Sql/servers/elasticPools/operations/cancel/action",
      "Microsoft.Sql/servers/elasticPools/operations/read",
      "Microsoft.Sql/managedInstances/databases/securityEvents/read",
      "Microsoft.Sql/locations/instanceFailoverGroups/read",
      "Microsoft.Sql/locations/instanceFailoverGroups/write",
      "Microsoft.Sql/locations/instanceFailoverGroups/delete",
      "Microsoft.Sql/locations/instanceFailoverGroups/failover/action",
      "Microsoft.Sql/locations/instanceFailoverGroups/forceFailoverAllowDataLoss/action",
      "Microsoft.Sql/servers/databases/providers/Microsoft.Insights/metricDefinitions/read",
      "Microsoft.Sql/servers/databases/providers/Microsoft.Insights/diagnosticSettings/read",
      "Microsoft.Sql/servers/databases/providers/Microsoft.Insights/diagnosticSettings/write",
      "Microsoft.Sql/servers/databases/providers/Microsoft.Insights/logDefinitions/read",
      "Microsoft.Sql/servers/elasticPools/providers/Microsoft.Insights/metricDefinitions/read",
      "Microsoft.Sql/servers/elasticPools/providers/Microsoft.Insights/diagnosticSettings/read",
      "Microsoft.Sql/servers/elasticPools/providers/Microsoft.Insights/diagnosticSettings/write",
      "Microsoft.Sql/servers/providers/Microsoft.Insights/metricDefinitions/read",
      "Microsoft.Sql/servers/replicationLinks/read",
      "Microsoft.Sql/managedInstances/encryptionProtector/read",
      "Microsoft.Sql/managedInstances/encryptionProtector/write",
      "Microsoft.Sql/managedInstances/keys/read",
      "Microsoft.Sql/managedInstances/keys/write",
      "Microsoft.Sql/managedInstances/keys/delete",
      "Microsoft.Sql/servers/databases/maintenanceWindowOptions/read",
      "Microsoft.Sql/servers/databases/maintenanceWindows/read",
      "Microsoft.Sql/servers/databases/maintenanceWindows/write",
      "Microsoft.Sql/servers/interfaceEndpointProfiles/write",
      "Microsoft.Sql/servers/interfaceEndpointProfiles/read",
      "Microsoft.Sql/servers/interfaceEndpointProfiles/delete",
      "Microsoft.Sql/locations/interfaceEndpointProfileAzureAsyncOperation/read",
      "Microsoft.Sql/locations/interfaceEndpointProfileOperationResults/read",
      "Microsoft.Sql/managedInstances/vulnerabilityAssessments/write",
      "Microsoft.Sql/managedInstances/vulnerabilityAssessments/delete",
      "Microsoft.Sql/managedInstances/vulnerabilityAssessments/read",
      "Microsoft.Sql/servers/vulnerabilityAssessments/write",
      "Microsoft.Sql/servers/vulnerabilityAssessments/delete",
      "Microsoft.Sql/servers/vulnerabilityAssessments/read",
      "Microsoft.Sql/managedInstances/providers/Microsoft.Insights/metricDefinitions/read",
      "Microsoft.Sql/managedInstances/providers/Microsoft.Insights/logDefinitions/read",
      "Microsoft.Sql/managedInstances/providers/Microsoft.Insights/diagnosticSettings/read",
      "Microsoft.Sql/managedInstances/providers/Microsoft.Insights/diagnosticSettings/write",
      "Microsoft.Sql/managedInstances/databases/providers/Microsoft.Insights/logDefinitions/read",
      "Microsoft.Sql/managedInstances/databases/providers/Microsoft.Insights/diagnosticSettings/read",
      "Microsoft.Sql/managedInstances/databases/providers/Microsoft.Insights/diagnosticSettings/write",
      "Microsoft.Sql/managedInstances/restorableDroppedDatabases/read",
      "Microsoft.Sql/managedInstances/databases/backupShortTermRetentionPolicies/read",
      "Microsoft.Sql/managedInstances/databases/backupShortTermRetentionPolicies/write",
      "Microsoft.Sql/managedInstances/restorableDroppedDatabases/backupShortTermRetentionPolicies/read",
      "Microsoft.Sql/managedInstances/restorableDroppedDatabases/backupShortTermRetentionPolicies/write",
      "Microsoft.Sql/servers/jobAgents/read",
      "Microsoft.Sql/servers/jobAgents/write",
      "Microsoft.Sql/servers/jobAgents/delete",
      "Microsoft.Sql/locations/jobAgentAzureAsyncOperation/read",
      "Microsoft.Sql/locations/jobAgentOperationResults/read",
      "Microsoft.Sql/managedInstances/databases/schemas/tables/columns/sensitivityLabels/read",
      "Microsoft.Sql/managedInstances/databases/schemas/tables/columns/sensitivityLabels/write",
      "Microsoft.Sql/managedInstances/databases/schemas/tables/columns/sensitivityLabels/delete",
      "Microsoft.Sql/managedInstances/databases/schemas/tables/columns/sensitivityLabels/disable/action",
      "Microsoft.Sql/managedInstances/databases/schemas/tables/columns/sensitivityLabels/enable/action",
      "Microsoft.Sql/managedInstances/databases/sensitivityLabels/read",
      "Microsoft.Sql/managedInstances/databases/currentSensitivityLabels/read",
      "Microsoft.Sql/managedInstances/databases/currentSensitivityLabels/write",
      "Microsoft.Sql/managedInstances/databases/recommendedSensitivityLabels/read",
      "Microsoft.Sql/servers/databases/currentSensitivityLabels/read",
      "Microsoft.Sql/servers/databases/currentSensitivityLabels/write",
      "Microsoft.Sql/servers/databases/recommendedSensitivityLabels/read",
      "Microsoft.Sql/locations/firewallRulesAzureAsyncOperation/read",
      "Microsoft.Sql/locations/firewallRulesOperationResults/read",
      "Microsoft.Sql/managedInstances/recoverableDatabases/read",
      "Microsoft.Sql/instancePools/read",
      "Microsoft.Sql/instancePools/write",
      "Microsoft.Sql/instancePools/delete",
      "Microsoft.Sql/locations/instancePoolAzureAsyncOperation/read",
      "Microsoft.Sql/locations/instancePoolOperationResults/read",
      "Microsoft.Sql/instancePools/usages/read",
      "Microsoft.Sql/managedInstances/databases/schemas/tables/columns/read",
      "Microsoft.Sql/managedInstances/databases/schemas/read",
      "Microsoft.Sql/managedInstances/databases/schemas/tables/read",
      "Microsoft.Sql/locations/managedInstanceKeyAzureAsyncOperation/read",
      "Microsoft.Sql/locations/managedInstanceKeyOperationResults/read",
      "Microsoft.Sql/locations/managedInstanceEncryptionProtectorAzureAsyncOperation/read",
      "Microsoft.Sql/locations/managedInstanceEncryptionProtectorOperationResults/read",
      "Microsoft.Sql/locations/serverKeyAzureAsyncOperation/read",
      "Microsoft.Sql/locations/serverKeyOperationResults/read",
      "Microsoft.Sql/locations/encryptionProtectorAzureAsyncOperation/read",
      "Microsoft.Sql/locations/encryptionProtectorOperationResults/read",
      "Microsoft.Sql/servers/privateEndpointConnections/read",
      "Microsoft.Sql/servers/privateEndpointConnections/delete",
      "Microsoft.Sql/servers/privateEndpointConnections/write",
      "Microsoft.Sql/locations/privateEndpointConnectionProxyOperationResults/read",
      "Microsoft.Sql/servers/privateEndpointConnectionProxies/validate/action",
      "Microsoft.Sql/servers/privateEndpointConnectionProxies/read",
      "Microsoft.Sql/servers/privateEndpointConnectionProxies/write",
      "Microsoft.Sql/servers/privateEndpointConnectionProxies/delete",
      "Microsoft.Sql/locations/privateEndpointConnectionProxyAzureAsyncOperation/read",
      "Microsoft.Sql/servers/databases/backupShortTermRetentionPolicies/read",
      "Microsoft.Sql/servers/databases/backupShortTermRetentionPolicies/write",
      "Microsoft.Sql/locations/privateEndpointConnectionOperationResults/read",
      "Microsoft.Sql/locations/privateEndpointConnectionAzureAsyncOperation/read",
      "Microsoft.Sql/servers/privateLinkResources/read",
    ]
  }
}
